function i = findnlargest(v, n)
% Find N largest elements of V (without using sort)
% Returns indices in increasing order

i = nan(n, 1);
ncrt = 1;
while ncrt <= n,
    vmax = max(v);              % maximum value (smaller than the last one)
    imax = find(v == vmax);     % make sure we know all the indices
    v(imax) = -Inf;             % replace with -Inf so that next time we find smaller values
    ntoadd = min(n-ncrt+1, length(imax));
    i(ncrt + (0:ntoadd-1)) = imax(1:ntoadd);
    ncrt = ncrt + ntoadd;
end;
i = sort(i);