function [IND, D] = knn(P, Q, K)
% Searck K nearest neighbors in P, for every point in Q
% Vectorized implementation by Lucian Busoniu

Np = size(P, 2); Nq = size(Q, 2);
IND = zeros(K, Nq); D = IND;
for i = 1:Nq,
    d = sum((P - repmat(Q(:, i), 1, Np)).^2);
    [d, ind] = sort(d);
    IND(:, i) = ind(1:K);
    D(:, i) = d(1:K);
end;

if nargout >= 2,
    D = sqrt(D);
end;