%% Hammerstein system of Ding & Chen 2005, Automatica
cd d:\work\m\approxrl\masystems\mahammerstein
macfg = struct; 
macfg.nagents = 5;
% circular topology 1->2->3->4->5->1, + 5->2, 2->4 to make it interesting
macfg.G =[0 0 0 0 1;
          1 0 0 0 1;
          0 1 0 0 0;
          0 1 1 0 0;
          0 0 0 1 0];
xmax = 5; x0 = 2 * xmax * rand(2, macfg.nagents) - xmax;
H = tf([0 .85 .65], [1 -1.6 0.8], 0.1, 'Variable', 'z^-1'); S = ss(H);
macfg.A = S.a; A = macfg.A;
macfg.B = S.b; B = macfg.B;
macfg.inputnl = @(u) u + 0.5 * u^2 + 0.25 * u^3;
macfg.Ts = 0.1;
Mu = 2*norm(inv([A*B B]), 2)*(1+norm(A, 2))*(3*norm([xmax; xmax], 2) + 0.1);
Mu = 300;
cfg = struct;
cfg.problem = 'mahamm_problem';
cfg.model_params = {macfg}; 
cfg.optparams.method = 'soo';
% cfg.optparams.diam = @(urange) 3*norm((urange(2, :) - urange(1, :))./2, 2);  % for DOO, assuming locally linear
cfg.optparams.dmax = @(t) sqrt(t); % for SOO
cfg.optparams.n = 200;
cfg.optparams.verb = 5;
cfg.trials = 1;
cfg.maxsteps = 50;
cfg.K = 2;
cfg.alpha = 0.2;
cfg.optparams.maxu = repmat(Mu, cfg.K, 1); % repeat bounds
cfg.optparams.verb = 0;
% regular initial states
cfg.reset = x0;
cfg.datafile = sprintf('oocons_mahamm_alpha%s_soo_n%d', num2strx(cfg.alpha, 'r'), cfg.optparams.n);
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.run = 1;
ooconsensus(cfg);

%% 
ooconsensus(['plottrial datafile=' cfg.datafile]);