function G = manonhol_buildgraph(m, x)
    % builds connectivity graph for a given state
    if size(x, 2) == 1, x = reshape(x, m.p(1), []); end;
    xc = x(m.conn, :);
    dxc = repmat(xc(:), 1, m.nagents) - repmat(xc, m.nagents, 1);
    dist = squeeze(sqrt(sum(reshape(dxc, length(m.conn), m.nagents, m.nagents).^2, 1)));
    G = dist <= m.range;
    G(1:m.nagents+1:m.nagents*m.nagents) = 0;     % set diagonal to 0 (no loops)
end