function [x, v] = learn_removeduplicates(x, v, cfg)
% removes duplicates from a learning database, keeping the smallest value
% see lipschitzlearn, llssvrlearn

[xtemp, irearrange] = sortrows(x');
vtemp = v(irearrange);
% indices where points are different (up to numerical tolerance) -- are starting points for the index ranges
ind = find([1; any(abs(diff(xtemp, 1)) > 1e-10, 2)]);
ind = [ind; size(xtemp, 1)+1];  % for the last interval
memsize = length(ind) - 1;
% init new memory
x = zeros(cfg.dimx, memsize); v = zeros(1, memsize);
% since hopefully most of the data will be unique, handle it efficiently
indsingle = (diff(ind) == 1)';
x(:, indsingle) = xtemp(ind([indsingle false]), :)';
v(indsingle) = vtemp(ind([indsingle false]))';
for i = find(~indsingle),
    % for x, take the first value -- should be fine
    x(:, i) = xtemp(ind(i), :)'; 
    % for each b(j), choose the minimum bound along all points
    v(i) = min(vtemp(ind(i):ind(i+1)-1));
end;
