function figh = plotplantree(tree)
%PLOTPLANTREE Show a graphical representation of a planning tree
%   Detailed explanation goes here

p = length(tree(1).x);
if p ~= 2, error('Can only plot tree for 2D state'); end;
X = zeros(2*p, 0);

for i = 1:length(tree),
    % find all children
    c = tree(i).children(:);
    c = c(~isnan(c));       % some children may be undefined if stochastic tree
    nc = length(c);
    % create endpoints for all the children
    xp = zeros(p, nc);
    for ic = 1:nc, xp(:, ic) = tree(c(ic)).x; end;
    % add the vectors to X
    X = [X [repmat(tree(i).x, 1, nc); xp]];
end;

figh = figure;
if p == 2,
    XX = X([1 3], :);
    YY = X([1 4], :);
    lh = line(XX, YY);
    set(lh, 'Color', 'k');
end;