
% a dummy model, to get the state var limits etc.
modelcfg = 'g=9.81 det=1 task=0';
dm = bike_problem('model', modelcfg);

% ========================
% common config, default reward function
failcfg = struct;
failcfg.problem = 'bike_problem';
failcfg.ugrids = symequidgrid(3, dm.maxu);
failcfg.gamma = 0.98;
failcfg.eps = 1e-3;
failcfg.maxiter = 1500;
failcfg.model_params = {modelcfg};
failcfg.initstepdisp = 0.025;

% Equidistant grids
fzcfg = failcfg;
fzcfg.run = 1;
fzcfg.xgrids = symequidgrid(11, dm.maxx);
fzcfg.datafile = 'fzbike_fail_N11eqM3eq';
if ~exist([fzcfg.datafile '.mat'], 'file'), fuzzyqi(fzcfg); end;

% Logarithmic grids
fzcfg = failcfg;
fzcfg.run = 1;
fzcfg.xgrids = symloggrid(11, dm.maxx);
fzcfg.datafile = 'fzbike_fail_N11logM3eq';
if ~exist([fzcfg.datafile '.mat'], 'file'), fuzzyqi(fzcfg); end;

% Logarithmic grids, N = 19
fzcfg = failcfg;
fzcfg.run = 1;
fzcfg.xgrids = symloggrid(19, dm.maxx);
fzcfg.datafile = 'fzbike_fail_N19logM3eq';
% if ~exist([fzcfg.datafile '.mat'], 'file'), fuzzyqi(fzcfg); end;


% ========================
% LQR config
lqrcfg = failcfg;
lqrcfg.model_params = {modelcfg, 'rewtype=lqr'};

% Logarithmic grids
fzcfg = lqrcfg;
fzcfg.run = 1;
fzcfg.xgrids = symloggrid(11, dm.maxx);
fzcfg.datafile = 'fzbike_lqr_N11logM3eq';
if ~exist([fzcfg.datafile '.mat'], 'file'), fuzzyqi(fzcfg); end;
