% find operating point
x0 = zeros(5, 1);
[x0, u0, y0] = trim('bike_standalone', x0, [], []);
% should remain all zeros
clear y0

% linearize
[A, B, C, D] = linmod('bike_standalone', x0, u0);
clear C D

% design LQR
lqreps = 1e-5;
Q = diag([10 lqreps lqreps lqreps 1]);
R = diag([.05 5]);
[K, S, e] = lqr(A, B, Q, R, 0);
% [X, D, K] = care(A, B, Q, R);
clear X D

% prepare K for use with state vector including x, y
K = [K zeros(2, 2)];
