function int_plotrew(rewtype)

Q = 1; R = 10;
maxx = 1; maxu = .1;
step = [.01 .001];
gamma = 0.95;
b = 1;

X = -maxx:step(1):maxx;
U = -maxu:step(2):maxu; 
XUf = flat({X, U}); 
Nf = length(XUf);
NXU = [length(X) length(U)];
Xpf = zeros(1, Nf);
rew = zeros(1, Nf);

q = 1/4; 
for i = 1:Nf,
    x = XUf(1, i); u = XUf(2, i); 
    xp = sat(x + b * u, -maxx, maxx);
    Xpf(:, i) = xp;
    switch rewtype,
        case 'shaping',
            r = -Q * x * x - R * u * u;
            rew(i) = r + gamma * shaping(xp, q) - shaping(x, q);
        case 'lqr',
            rew(i) = -Q * x * x - R * u * u;
    end;
end;

mesh(X, U, reshape(rew, NXU)');
xlabel('x');
ylabel('u');

end


function s = shaping(x, q)
s = -floor(abs(x) / q);
% s = -x^2;
end