function dd_fzqi_resstudy(mode, cfg)
% Discrete double integrator. Resolution study with fuzzy Q-iteration
% These experiments are:
%   - run in Feb 2009, 
%   - on the new DCSC desktop machines (Dell Optiplex 755)

% What experiments to process and in what mode (defaults)
if nargin < 1, mode = 'run'; end;
if nargin < 2, cfg = struct; end;

% default (main) CFG
CFG = struct;
CFG.(mode) = 1;
CFG.problem = 'ddi_problem';
CFG.gamma = 0.95;
CFG.N = 4:30;
cfg.M = 2;              % only 2 actions throughout
CFG.maxiter = 2000;
CFG.eps = 1e-5;
% perf eval config
CFG.X0 = 'p01s02';
CFG.mc_eps = 0.001;
CFG.datadir = [pwd '\'];
CFG.datafile = 'dd_fzqi_resstudy_scorecache';
% fig config
CFG = setfigprop(CFG, 'addfields');
CFG.xgridfigure = 'off';      % since qiresstudy makes it 'on' by default
CFG.legendprefix = ''; CFG.legendpostfix = '';
CFG.xlabel = [];


% install any non-default config; preserve the default
cfg = parseconfig(cfg, CFG);

% run the experiment
qiresstudy(cfg);

end