function dx = invpend_trans(t, x, m, u)
%  Implements the transition function of the inverted pendulum
%
%  Parameters:
%   T           - the current time. Ignored, added for compatibility with
%               the ODEXX function style.
%   X           - the current state
%   M           - the model structure specifying physical params
%   U           - the command
%
%  Returns:
%   DX          - the derivative of the state
%

dx(1,1) = x(2);
dx(2,1) = (m.mgR*sin(x(1)) - m.b*x(2) + m.K*u) / m.J;

% end INVPEND_TRANS returning DX
