
% Main M-file

clear all;

if ~exist('cart_gridqi.mat', 'file'),
    gridqi('run problem=cart_problem datafile=cart_gridqi');
end;

load cart_gridqi

V = reshape(max(theta, [], 2), DIMS.dimx);

figh = figure; 

% plotting the V-function
mesh(X0{1}, X0{2}, V');

% plotting the h-function
h = zeros(DIMS.N, 1);
U = U{1};
for i = 1:DIMS.N,
    Qa = theta(i, :);
    ua = U(Qa == max(Qa));
    ui = find(abs(ua) == max(abs(ua)), 1);
    h(i) = ua(ui);
end;

figh(end+1) = figure; 
ph = pcolor(X0{1}, X0{2}, reshape(h, DIMS.dimx)');
set(ph, 'LineStyle', 'none'); hold on; 
% xlabel(labels.x{:}); ylabel(labels.y{:}); title(labels.h{:});
colormap(gray);
