function [xplus, rplus, terminal] = cart_mdp(m, x, u)
% Implements the discrete double integrator with
% bounded position and velocity, controlled in acceleration.
%  [XPLUS, RPLUS, TERMINAL] = DDI_MDP(M, X, U, W)
% Model restricted to deterministic, and quadratic reward
%
% This function conforms to the specifications established by SAMPLE_MDP.

% dynamics w/ bounded state
xplus = max(-m.maxx, min(m.maxx, m.A * x + m.B * u));
% goal: exit through + or -1 with as little speed as possible
rplus = -x' * m.Q * x - m.R * u^2;

terminal = 0;
    
% END FUNCTION -----
