function [xplus, rplus, terminal] = quad_dyn(m, x, u)
% Implements the dynamics of a quadrotor
%  [XPLUS, RPLUS, TERMINAl] = SWITCHEDLIN_MDP(M, X, U)
% This function conforms to the specifications established by SAMPLE_MDP.

if ~any(m.U == u), error('Invalid mode'); end;

cost = 0;
xsat = min(max(x, -m.maxx), m.maxx);
cost = cost + (xsat-m.goal)' * m.Q * (xsat-m.goal);
if any(x ~= xsat), disp('Warning: bounds reached'); end;

if u == 1
    m.trans = @quaddyn1;
    x = numerical_integ(m,x,0.003);
elseif u ==2
    m.trans = @quaddyn2;
    x = numerical_integ(m,x,0.003);
elseif u ==3
    m.trans = @quaddyn3;
    x = numerical_integ(m,x,0.003);
elseif u ==4
    m.trans = @quaddyn1;
    x = numerical_integ(m,x,0);
elseif u ==5
    m.trans = @quaddyn2;
    x = numerical_integ(m,x,0);
end
   
xplus = x;
if any(abs(xplus) > m.maxx), error('Bounds exceeded'); end;

if m.rewtype(1) == 'o',
    rplus = 1 - cost / m.maxcost;
else    % variant to get the worst possible cost and check the bound
    rplus = cost / m.maxcost;
end;

terminal = 0;

% END FUNCTION linsys_mdp() RETURNING xplus, rplus ==================================================