% Nonlinear example

%% config
clear all;
x0 = [0; 1; 0.1; 0; 0; 0];
mcfg.Ts = 0.05;

mcfg.Q = diag([1 1 0.1 0 0 0]);
mcfg.goal = [6; 1; 0; 0; 0; 0];
mcfg.maxx = [10; 10; 10; 10; 10; 10];
mcfg.rewtype = 'opt';

cfg = struct;
cfg.problem = 'switched_quad';
cfg.model_params = {mcfg};
cfg.gamma = .99;
cfg.maxsteps = 5/mcfg.Ts;
cfg.planalg = 'opd';
cfg.planparams.U = 1:5;
cfg.planparams.n = 100;
cfg.verb = 3;

%% run OPD allowing any initial mode
cfg.reset = x0;
cfg.run = 1;
cfg.datafile = 'swlin_quad_test';
genmpc(cfg);

h = genmpc(['plottrial datafile=' cfg.datafile]);
% h.R(1)
% cost = 0; for i = 1:length(h.x), cost = cost + h.x(:, i)' * mcfg.Q * h.x(:, i); end;
% cost
