function ccfg = common_config_quadmulti()
mcfg.rewtype = 'nlqr';
mcfg.xgoal = zeros(13,10);
mcfg.xgoal(:,1) = [6 0 1, 0 0 0, 0 0 0, 0 0 0, 0]';
mcfg.xgoal(:,2) = [9 2 1, 0 0 0, 0 0 0, 0 0 0, 0]';
mcfg.xgoal(:,3) = [8 5 1, 0 0 0, 0 0 0, 0 0 0, 0]';
mcfg.xgoal(:,4) = [5 4 1, 0 0 0, 0 0 0, 0 0 0, 0]';
mcfg.xgoal(:,5) = [1 2 1, 0 0 0, 0 0 0, 0 0 0, 0]';
mcfg.wptNr = 5;

% mcfg.xgoal(:,1) = [6 6 1, 0 0 0, 0 0 0, 0 0 0, 0]';
% mcfg.wptNr = 1;

% simplify integration for test purposes
% mcfg.Ts = 0.1;
% mcfg.odemethod = 'euler';
% % mcfg.odesolver = @ode4;
% mcfg.odesteps = 1;

ccfg = struct;
ccfg.problem = 'quadmulti_problem';
ccfg.model_params = {mcfg}; 
ccfg.gamma = 0.98;               

ccfg.planparams = struct;
%U=[Ucoll-up, Uphi-dy, Utheta-dx, Upsi-rot]
% ccfg.planparams.U = flat({[1.2508, 0, 20.0126], [-1.1807, 0, 1.1807], [-1.1807, 0, 1.1807], [-0.0488, 0, 0.0488]});    % action space -- the same as for M=3 in the approximators above
% ccfg.planparams.U = flat({[1.2508, 4.3, 10], 0, [-0.01, 0, 0.01], 0});    % action space -- the same as for M=3 in the approximators above
ccfg.planparams.U = flat({9.80665*0.5, 0, [-0.001, 0, 0.001], [-0.002, 0, 0.002]});    % action space -- the same as for M=3 in the approximators above
% ccfg.planparams.U = flat({9.80665*0.5, 0, [-0.001, 0, 0.001], [-0.01, 0, 0.01]});    % Lucian: increased turning input
% hover = 9.80665*0.5;
% ccfg.planparams.U = [hover 0 -.001 0; hover 0 .001 0; hover 0 0 -.01; hover 0 0 .01]';
% PAR.minu = [1.2508   -1.1807   -1.1807   -0.0488]';
% PAR.maxu = [20.0126   1.1807    1.1807    0.0488]';
% we should replace these with macro actions

ccfg.verb = 3;
ccfg.reset = [4.5 0 1, 0 0 0, 0 0 0, 0 0 0, 1]';          % always reset to landed
ccfg.trials = 1;                 % one trial is enough to see performance, as we're not learning
ccfg.maxsteps = 200;

ccfg.datadir = pwd;     % output config
ccfg.visualize = 0;     % if using visualization -- set visualize to 0 to disable