function [varargout] = quad_visualize(cfg)
eval(sprintf('%s=evalin(''caller'', ''%s'');', 'X', 'X')); 
eval(sprintf('%s=evalin(''caller'', ''%s'');', 'model', 'model')); 
cfg.xgoal = model.xgoal;
cfg.x0 = X(:,1);
cfg.wptNr = model.wptNr;
P = X(:,cfg.k+1); %pose of the drone
gview = struct; gview.figh = figure(1);

%p_x = X(1), p_y, p_z, p_roll, p_pitch, p_yaw
[az, el] = view;%get(handles.axes, 'view'); 

drone.crosslength = 0.32;
drone.circ_radius = 0.12;
drone.proplength = 0.20;

% define drone components, with respect to (0,0,0)
drone.zero = point(0,0,0);
%drone.origo = point(0,0,0);

drone.rod1 = rod(drone.zero, drone.crosslength,  45);
drone.rod2 = rod(drone.zero, drone.crosslength, 135);

drone.mot1 = crosspoint(drone.crosslength,  45);
drone.mot2 = crosspoint(drone.crosslength, 135);
drone.mot3 = crosspoint(drone.crosslength, 225);
drone.mot4 = crosspoint(drone.crosslength, 315);

drone.rot1 = rotor(drone.mot1, drone.circ_radius);
drone.rot2 = rotor(drone.mot2, drone.circ_radius);
drone.rot3 = rotor(drone.mot3, drone.circ_radius);
drone.rot4 = rotor(drone.mot4, drone.circ_radius);

prop_ang=0;
ang = prop_ang * 40+10;
prop_ang = prop_ang + 1;
drone.prop1 = rod(drone.mot1, drone.proplength, ang);
drone.prop2 = rod(drone.mot2, drone.proplength, -ang);
drone.prop3 = rod(drone.mot3, drone.proplength, ang);
drone.prop4 = rod(drone.mot4, drone.proplength, -ang);


%%%here we need the current position of the drone, and the rotation
%P=x,y,z, roll, pitch, yaw
pos = point(P(1),P(2),P(3));

%P=x,y,z, roll, pitch, yaw
drone = rotate(drone, P(4),P(5),P(6));
%drone = translate(drone, drone.origo);
drone = translate(drone, pos);

    
colorRot = [0.2 0.2 0.2];
colorRod = [0.6 0.6 0.6];
colorProp = [0.6 0.2 0.2];

hold off;
plot3(drone.rod1(1,:), drone.rod1(2,:), drone.rod1(3,:),'Color',colorRod, 'LineWidth',1.5);    
%axis([0 4 -2 2 0 1]);
%axis([3 7 -0.5 5 0 2]);
inc = 3;
wx = [min([cfg.xgoal(1,1:cfg.wptNr) cfg.x0(1)])-inc  max([cfg.xgoal(1,1:cfg.wptNr) cfg.x0(1)])+inc ];
wy = [min([cfg.xgoal(2,1:cfg.wptNr) cfg.x0(2)])-inc  max([cfg.xgoal(2,1:cfg.wptNr) cfg.x0(2)])+inc ];
if (wx(2)-wx(1)>wy(2)-wy(1)), wy(2) = wy(1) + wx(2)-wx(1); end;
if (wy(2)-wy(1)>wx(2)-wx(1)), wx(2) = wx(1) + wy(2)-wy(1); end;

wz = [min([cfg.xgoal(3,1:cfg.wptNr) cfg.x0(3)])-1 max([cfg.xgoal(3,1:cfg.wptNr) cfg.x0(3)])+1];
axis([wx wy wz]);
%    axis([fig_x fig_y fig_z]);
%    axis([-10 10 -10 10 -10 10]);
%    axis([0.5 1.5 -0.5 0.5 0.5 1.5]);
%    xlim([-5 5]);ylim([-5 5]);zlim([0 5]);
hold on;
%zoom on;
plot3(drone.rod2(1,:), drone.rod2(2,:), drone.rod2(3,:),'Color',colorRod, 'LineWidth',1.5);

%plot the hull
plot3(drone.rot1(1,:), drone.rot1(2,:), drone.rot1(3,:),'Color',colorRot, 'LineWidth',2.5);
plot3(drone.rot2(1,:), drone.rot2(2,:), drone.rot2(3,:),'Color',colorRot, 'LineWidth',2.5);
plot3(drone.rot3(1,:), drone.rot3(2,:), drone.rot3(3,:),'Color',colorRot, 'LineWidth',2.5);
plot3(drone.rot4(1,:), drone.rot4(2,:), drone.rot4(3,:),'Color',colorRot, 'LineWidth',2.5);

%plot the rotor blades
plot3(drone.prop1(1,:), drone.prop1(2,:), drone.prop1(3,:),'Color',colorProp, 'LineWidth',1.5);
plot3(drone.prop2(1,:), drone.prop2(2,:), drone.prop2(3,:),'Color',colorProp, 'LineWidth',1.5);
plot3(drone.prop3(1,:), drone.prop3(2,:), drone.prop3(3,:),'Color',colorProp, 'LineWidth',1.5);
plot3(drone.prop4(1,:), drone.prop4(2,:), drone.prop4(3,:),'Color',colorProp, 'LineWidth',1.5);

%plot targets
for i=1:cfg.wptNr
    plot3(cfg.xgoal(1,i),cfg.xgoal(2,i),cfg.xgoal(3,i),'x','Color',colorProp, 'LineWidth',1.5);
end;

%plot flight path
plot3(X(1,1:cfg.k+1), X(2,1:cfg.k+1), X(3,1:cfg.k+1), 'Color',colorRot);

grid on;   

%view (handles.az, handles.el);
view (az, el);
%set(gca,'view',v);

  
varargout = {gview.figh, gview};

  
  
function pont = translatePoint(pont, origo)
pont(1,:) = origo(1,:) + pont(1,:);
pont(2,:) = origo(2,:) + pont(2,:);
pont(3,:) = origo(3,:) + pont(3,:);


function translateddrone = translate (drone, toPos)
translateddrone = drone;
translateddrone.mot1 = translatePoint(drone.mot1, toPos);
translateddrone.mot2 = translatePoint(drone.mot2, toPos);
translateddrone.mot3 = translatePoint(drone.mot3, toPos);
translateddrone.mot4 = translatePoint(drone.mot4, toPos);

translateddrone.rot1 = translatePoint(drone.rot1, toPos);
translateddrone.rot2 = translatePoint(drone.rot2, toPos);
translateddrone.rot3 = translatePoint(drone.rot3, toPos);
translateddrone.rot4 = translatePoint(drone.rot4, toPos);

translateddrone.prop1 = translatePoint(drone.prop1, toPos);
translateddrone.prop2 = translatePoint(drone.prop2, toPos);
translateddrone.prop3 = translatePoint(drone.prop3, toPos);
translateddrone.prop4 = translatePoint(drone.prop4, toPos);

translateddrone.rod1 = translatePoint(drone.rod1, toPos);
translateddrone.rod2 = translatePoint(drone.rod2, toPos);

translateddrone.origo = translatePoint(drone.zero, toPos);



function rotated = rotateYaw(point, roll, pitch, yaw)
% rotations with NED (north-east-down) convention, where z-axis poitns down
% and x,y-axes are inversed
% Ryaw =   [cos(yaw) sin(yaw) 0; -sin(yaw) cos(yaw) 0; 0 0 1];
% Rpitch = [cos(pitch) 0 -sin(pitch); 0 1 0; sin(pitch) 0 cos(pitch)];
% Rroll =  [1 0 0; 0 cos(roll) sin(roll); 0 -sin(roll) cos(roll)];
Ryaw =   [cos(yaw) -sin(yaw) 0; 
          sin(yaw)  cos(yaw) 0; 
            0          0     1];

Rpitch = [cos(pitch) 0 sin(pitch); 
            0        1      0; 
         -sin(pitch) 0 cos(pitch)];

Rroll =  [  1     0         0; 
            0  cos(roll) -sin(roll); 
            0  sin(roll) cos(roll)];
        R = Ryaw * Rpitch * Rroll;
rotated = R * point;


function dronerotated = rotate(drone, roll, pitch, yaw)
dronerotated = drone;
dronerotated.mot1 = rotateYaw(drone.mot1, roll, pitch, yaw);
dronerotated.mot2 = rotateYaw(drone.mot2, roll, pitch, yaw);
dronerotated.mot3 = rotateYaw(drone.mot3, roll, pitch, yaw);
dronerotated.mot4 = rotateYaw(drone.mot4, roll, pitch, yaw);

dronerotated.rot1 = rotateYaw(drone.rot1, roll, pitch, yaw);
dronerotated.rot2 = rotateYaw(drone.rot2, roll, pitch, yaw);
dronerotated.rot3 = rotateYaw(drone.rot3, roll, pitch, yaw);
dronerotated.rot4 = rotateYaw(drone.rot4, roll, pitch, yaw);

dronerotated.prop1 = rotateYaw(drone.prop1, roll, pitch, yaw);
dronerotated.prop2 = rotateYaw(drone.prop2, roll, pitch, yaw);
dronerotated.prop3 = rotateYaw(drone.prop3, roll, pitch, yaw);
dronerotated.prop4 = rotateYaw(drone.prop4, roll, pitch, yaw);

dronerotated.rod1 = rotateYaw(drone.rod1, roll, pitch, yaw);
dronerotated.rod2 = rotateYaw(drone.rod2, roll, pitch, yaw);


function point = crosspoint(crosslength, angle)
point(1,:) = crosslength/2 * cos(angle*pi/180);
point(2,:) = crosslength/2 * sin(angle*pi/180);
point(3,:) = 0;


function circle = rotor(pos, circ_radius)
circ_t = 0:pi/10:2*pi;
circle(1,:) = pos(1,:) + circ_radius * cos(circ_t);
circle(2,:) = pos(2,:) + circ_radius * sin(circ_t);
circle(3,:) = pos(3,:) + 0*circ_t;


function cross = rod(pos, crosslength, angle)
rod_t = [-crosslength/2 crosslength/2];
cross(1,:) = pos(1,:) + cos(angle*pi/180) * rod_t;
cross(2,:) = pos(2,:) + sin(angle*pi/180) * rod_t;
cross(3,:) = pos(3,:) + 0 * rod_t;


function pont = point(x,y,z)
pont(1,:) = x;
pont(2,:) = y;
pont(3,:) = z;
%pont = rotate(handles, pont);


