close all;  clear all;
Uval = 2;
Uvals = '_U2';
ccfg = ip_common_config(Uval);
[approx, theta] = fuzzyqi(['approx datafile=ip_fzqi_nearopt' Uvals]);
ccfg.hstar = @(x) approx.h(approx, theta, x);
ccfg.Qstar = @(x, u) approx.q(approx, theta, x, u); 

showRegretGraph = false;
showDepthGraph = true;
avgDepthGrapth = true;
showVarK = true;
knr = 5;  %in case the depth graph is not the avg of all x0

%% IP offline tests for different n, epsil=10
K = 16;
M = 3;
narray = [600:300:4500 6000 7500];
testParamNames = '_U=2_K=16';

opdavgreg=narray;
okp_avgreg=narray;
okpEqTree_avgreg=narray;
nearopt=narray;
Kopd=narray;
Kokp=narray;
Kokp_eqtree=narray;
cfg = ccfg;

for n=narray,
    if showRegretGraph,
        cfg.datafile = ['ipoff_opd' testParamNames '_nsim=' num2str(n)];
        [opdavgreg(narray==n) opdreg(narray==n,:)] = genmpc_exp('regret', cfg);

        cfg.datafile = ['ipoff_okp' testParamNames '_nsim=' num2str(n)];
        [okp_avgreg(narray==n) okpreg(narray==n,:)] = genmpc_exp('regret', cfg);

        cfg.datafile = ['ipoff_okp' testParamNames '_eqTree_nsim=' num2str(n)];
        [okpEqTree_avgreg(narray==n) okpEqTreereg(narray==n,:)] = genmpc_exp('regret', cfg);
        if ~avgDepthGrapth,
            avgReg = 0;
            for i=[196+[0:knr-1] 208-[0:knr-1]], avgReg = avgReg + opdreg(narray==n,i); end
            avgReg = double(avgReg)/(2*knr);
            opdavgreg(narray==n) = avgReg;
            avgReg = 0;
            for i=[196+[0:knr-1] 208-[0:knr-1]], avgReg = avgReg + okpreg(narray==n,i); end
            avgReg = double(avgReg)/(2*knr);
            okp_avgreg(narray==n) = avgReg;
            avgReg = 0;
            for i=[196+[0:knr-1] 208-[0:knr-1]], avgReg = avgReg + okpEqTreereg(narray==n,i); end
            avgReg = double(avgReg)/(2*knr);
            okpEqTree_avgreg(narray==n) = avgReg;
        end
    end;
    if showDepthGraph,
        if avgDepthGrapth,
            cfg.datafile = ['ipoff_opd' testParamNames '_nsim=' num2str(n)];
            load(cfg.datafile);
            avgK=0; 
            for i=1:size(planinfoh,2), avgK = avgK + planinfoh(i).depth; end
            avgK = double(avgK)/size(planinfoh,2);
            Kopd(narray==n) = avgK; %cfg.gamma^double(avgK)/(1-cfg.gamma);        

            cfg.datafile = ['ipoff_okp' testParamNames '_nsim=' num2str(n)];
            load(cfg.datafile);
            avgK=0; 
            for i=1:size(planinfoh,2), avgK = avgK + planinfoh(i).Kdepth; end
            avgK = double(avgK)/size(planinfoh,2);
            Kokp(narray==n) = avgK; %cfg.gamma^double(avgK)/(1-cfg.gamma);        

            cfg.datafile = ['ipoff_okp' testParamNames '_eqTree_nsim=' num2str(n)];
            load(cfg.datafile);
            avgK=0; 
            for i=1:size(planinfoh,2), avgK = avgK + planinfoh(i).Kdepth; end
            avgK = double(avgK)/size(planinfoh,2);
            Kokp_eqtree(narray==n) = avgK; %cfg.gamma^double(avgK)/(1-cfg.gamma);        
        else
            %THE (-pi,0) state and around
            cfg.datafile = ['ipoff_opd' testParamNames '_nsim=' num2str(n)];
            load(cfg.datafile);
            avgK=0;     
            for i=[196+[0:knr-1] 208-[0:knr-1]], avgK = avgK + planinfoh(i).depth; end
            avgK = double(avgK)/(2*knr);
            Kopd(narray==n) = avgK;

            cfg.datafile = ['ipoff_okp' testParamNames '_nsim=' num2str(n)];
            load(cfg.datafile);
            avgK=0;     
            for i=[196+[0:knr-1] 208-[0:knr-1]], avgK = avgK + planinfoh(i).Kdepth; end
            avgK = double(avgK)/(2*knr);
            Kokp(narray==n) = avgK; %cfg.gamma^double(avgK)/(1-cfg.gamma);        

            cfg.datafile = ['ipoff_okp' testParamNames '_eqTree_nsim=' num2str(n)];
            load(cfg.datafile);
            avgK=0;     
            for i=[196+[0:knr-1] 208-[0:knr-1]], avgK = avgK + planinfoh(i).Kdepth; end
            avgK = double(avgK)/(2*knr);
            Kokp_eqtree(narray==n) = avgK; %cfg.gamma^double(avgK)/(1-cfg.gamma);        
        
        end;
    end
end;

if showRegretGraph,
    figure;
    plot(narray,opdavgreg,'-s', narray,okp_avgreg,'-*', narray,okpEqTree_avgreg,'-o');
    legend('OPD','OKP','OKP equal treesize');
    title(['IP average regret for various n, ' testParamNames]);
end;

if showDepthGraph,
    figure;
    plot(narray,Kopd-1,'-s', narray,Kokp,'-*', narray,Kokp_eqtree,'-o');
    legend('OPD','OKP','OKP equal treesize');
    title(['IP average treedepth (expanded) for various n, ' testParamNames]);
end;

if showVarK,
    %% IP offline tests for different K, epsil=10^-10
    n=640;
    Karray = [1 2 4 5 8 10 16 20 32];
    opdavgreg=Karray;
    okp_avgreg=Karray;
    okpEqTree_avgreg=Karray;
    Kopd=Karray;
    Kokp=Karray;
    Kokp_eqtree=Karray;
    for K=Karray,
        if showRegretGraph,
            cfg.datafile = ['ipoff_U2_opd_n=' num2str(n)];
            [opdavgreg(Karray==K)] = genmpc_exp('regret', cfg);

            cfg.datafile = ['ipoff_U2_okp_expred_n=' num2str(n) 'K=' num2str(K)];
            [okp_avgreg(Karray==K)] = genmpc_exp('regret', cfg);

            cfg.datafile = ['ipoff_U2_okp_expred_eqTree_n=' num2str(n) 'K=' num2str(K)];
            [okpEqTree_avgreg(Karray==K)] = genmpc_exp('regret', cfg);
        end;

        if showDepthGraph,
            if avgDepthGrapth,
                cfg.datafile = ['ipoff_U2_opd_n=' num2str(n)];
                load(cfg.datafile);
                avgK=0; 
                for i=1:size(planinfoh,2), avgK = avgK + planinfoh(i).depth; end
                avgK = double(avgK)/size(planinfoh,2);
                Kopd(Karray==K) = avgK; %cfg.gamma^double(avgK)/(1-cfg.gamma);        

                cfg.datafile = ['ipoff_U2_okp_expred_n=' num2str(n)  'K=' num2str(K)];
                load(cfg.datafile);
                avgK=0; 
                for i=1:size(planinfoh,2), avgK = avgK + planinfoh(i).Kdepth; end
                avgK = double(avgK)/size(planinfoh,2);
                Kokp(Karray==K) = avgK; %cfg.gamma^double(avgK)/(1-cfg.gamma);        

                cfg.datafile = ['ipoff_U2_okp_expred_eqTree_n=' num2str(n)  'K=' num2str(K)];
                load(cfg.datafile);
                avgK=0; 
                for i=1:size(planinfoh,2), avgK = avgK + planinfoh(i).Kdepth; end
                avgK = double(avgK)/size(planinfoh,2);
                Kokp_eqtree(Karray==K) = avgK; %cfg.gamma^double(avgK)/(1-cfg.gamma);        
            else
                %THE (-pi,0) state and around
                cfg.datafile = ['ipoff_U2_opd_n=' num2str(n)];
                load(cfg.datafile);
                avgK=0;     
                for i=[196+[0:knr-1] 208-[0:knr-1]], avgK = avgK + planinfoh(i).depth; end
                avgK = double(avgK)/(2*knr);
                Kopd(Karray==K) = avgK;

                cfg.datafile = ['ipoff_U2_okp_expred_n=' num2str(n) 'K=' num2str(K)];
                load(cfg.datafile);
                avgK=0;     
                for i=[196+[0:knr-1] 208-[0:knr-1]], avgK = avgK + planinfoh(i).Kdepth; end
                avgK = double(avgK)/(2*knr);
                Kokp(Karray==K) = avgK; %cfg.gamma^double(avgK)/(1-cfg.gamma);        

                cfg.datafile = ['ipoff_U2_okp_expred_eqTree_n=' num2str(n) 'K=' num2str(K)];
                load(cfg.datafile);
                avgK=0;     
                for i=[196+[0:knr-1] 208-[0:knr-1]], avgK = avgK + planinfoh(i).Kdepth; end
                avgK = double(avgK)/(2*knr);
                Kokp_eqtree(Karray==K) = avgK; %cfg.gamma^double(avgK)/(1-cfg.gamma);        

            end;
        end
    end;

    if showRegretGraph,
        figure;
        plot(Karray,opdavgreg,'-s', Karray,okp_avgreg,'-*', Karray,okpEqTree_avgreg,'-o');
        legend('OPD','OKP','OKP equal treesize');
        title('IP average regret for various K, n=640');
    end;

    if showDepthGraph,
        figure;
        plot(Karray,Kopd-1,'-s', Karray,Kokp,'-*', Karray,Kokp_eqtree,'-o');
        legend('OPD','OKP','OKP equal treesize');
        title('IP average treedepth (expanded) for various K, n=640');
    end;
end;