cfg.tend = 30;

% model
model = sw_problem('model');
% initial state: on the limit cycle
x0 = [0.1534 2*0.1534 -0.1561 0];

disp(['Autonomous motion of simple walker from x0=' num2str(reshape(x0, 1, [])) ]);

% history
t = 0 : model.Ts : cfg.tend;
x = zeros(4, length(t)); x(:, 1) = x0;
u = zeros(1, length(t)); u(:, end) = NaN;
r = zeros(1, length(t)); r(1) = NaN;

% steps loop
for k = 1:length(t)-1,
    % apply to system
    [x(:, k+1) r(k+1)] = feval(model.fun, model, x(:, k), u(:, k));
end;

% plot history & optionally save figures
hist.t = t; hist.x = x; hist.u = u; hist.r = r;
figh = plothistory(hist);
% if the model supplies a plot function, use it to plot the trajectory
if isfield(model, 'plotfun'),
    figh(end+1) = feval(model.plotfun, hist);
end;

% pause; close(figh);
        
