% Script to test DOO and SOO optimization

%% 1D
cfg.fun = @(u, ustar, delta) delta-(u-ustar)^2;
cfg.funargs = {2, 40};
cfg.maxu = 5;
cfg.diam = @(int) ((int(2)-int(1))/2)^2;
cfg.method = 'soo';
cfg.n = 25;
cfg.dmax = @(tau) tau^.7;
cfg.verb = 4;

[ustar, info, data] = doosoo(cfg);

%% 2D
cfg.fun = @(u, ustar, delta) delta-norm(u-ustar, inf)^2;
cfg.funargs = {[0.33 0.33]', 4};
cfg.maxu = [1 2]';
cfg.diam = @(int) norm((int(2, :)-int(1, :)) / 2, inf)^2;
cfg.method = 'soo';
cfg.n = 25;
cfg.verb = 4;

[ustar, info, data] = doosoo(cfg);

%% 2D more complicated
cfg.fun = @(x) 500-100*(x(2)-x(1)^2)^2-(1-x(1))^2;
cfg.funargs = {};
cfg.maxu = [1.9; 2.23];
cfg.diam = @(int) 200*norm((int(2, :)-int(1, :)) / 2, 2)^2;
cfg.method = 'doo';
cfg.n = 100;
cfg.verb = 4;

[ustar, info, data] = doosoo(cfg);