%% main config
ccfg = struct;
ccfg.gamma = .98;
ccfg.datadir = pwd;
% the "standard" ipsetup approximator
ccfg.approx = 'enhanced type=rbfdisc N=11 M=3';
% and learning settings
ccfg.maxtime  = 500;
ccfg.trialtime = 2;
ccfg.dupd = 2;
ccfg.explor = 1;
ccfg.explordecay = .995;
ccfg.randseed = 1000;
% reset 
ccfg.reset = 'rand';
% stats settings
ccfg.dstoretheta = 10;
ccfg.verb = 3;
ccfg.eps = 0;


%% run real-time algorithm, with dummy problem
cfg = ccfg;
cfg.problem = 'ipsetup_dummy_rtproblem';
cfg.run = 1;
cfg.datafile = 'test_rtlspionline_ip';
cfg.decaytype = 'second';       % for compatibilityh with lspionline
rtlspionline(cfg);


%% run simulation algorithm, as a baseline
cfg = ccfg;
cfg.problem = 'ipsetup_problem';
cfg.run = 1;
cfg.datafile = 'test_rtlspionline_ip_lspionlinebaseline';
lspionline(cfg);

% Note the solutions should be IDENTICAL for the same random seed and parameters
% (they are)



%% run real-time in "debug" mode, with very short trials etc.
cfg = ccfg;
cfg.run = 1;
cfg.problem = 'ipsetup_dummy_rtproblem';
cfg.maxtime = .5;
cfg.trialtime = .1;
cfg.dupd = .03;
cfg.datafile = 'test_rtlspionline_ip_debug';
cfg.decaytype = 'trial';
cfg.verb = 5;
rtlspionline(cfg);

%% run simulation in "debug" mode, with very short trials etc.
cfg = ccfg;
cfg.run = 1;
cfg.problem = 'ipsetup_problem';
cfg.maxtime = .5;
cfg.trialtime = .1;
cfg.dupd = .03;
cfg.datafile = 'test_lspionline_ip_debug';
cfg.verb = 5;
lspionline(cfg);