%% Init
ccfg = struct;
ccfg.problem = 'hillcar_problem';
ccfg.gamma = .98;
ccfg.datadir = 'd:\work\m\approxrl\testing\test_terminalstates\';
ccfg.term = 'zero';
% 
% %% Grid QI
% cfg = ccfg;
% cfg.run = 1;
% cfg.datafile = 'hc_testterm_gridqi';
% cfg.xgrids = {-1:2/50:1, -3:6/50:3};
% cfg.ugrids = {[-4 4]};
% gridqi(cfg);
% 
% 
% %% Fitted QI
% cfg = ccfg;
% cfg.run = 1;
% cfg.datafile = 'hc_testterm_fittedqi';
% cfg.U = {[-4 4]};                         % discrete action space (cell array of grids, or flat)
% cfg.samples = 'method=randdisc N=3000';
% cfg.maxiter = 50;                   
% cfg.eps = 0.1;                      
% cfg.regmethod = 'extratrees';       
% cfg.singlereg = 1;                  
% % regression options for extratrees
% cfg.trees_ntrees = 25;                % # of trees for ensemble methods
% cfg.trees_nmin = 2;                   % nmin param for extra trees
% fittedqi(cfg);
% 
% 
% %% LSPI
% 
% cfg = ccfg;
% cfg.run = 1;
% cfg.maxiter  = 50;
% cfg.eps = 0.01;        % make this small since the rewards have small magnitude in the hillcar problem
% cfg.epsper = 0.01;
% cfg.approx.enhanced = 1;
% cfg.approx.type = 'triang';
% cfg.approx.N = [11 11]; cfg.approx.xspace = 'eq';
% cfg.approx.M = 2; cfg.approx.uspace = 'eq';
% cfg.samples = 'randdisc N=10000';
% cfg.datafile = 'hc_testterm_lspi';
% lspi(cfg);
% 
% 
% %% LSPE
% 
% cfg = ccfg;
% cfg.run = 1;
% cfg.maxiter  = 50;
% cfg.eps = 0.01;
% cfg.epsper = 0.01;
% cfg.approx.enhanced = 1;
% cfg.approx.type = 'triang';
% cfg.approx.N = [11 11]; cfg.approx.xspace = 'eq';
% cfg.approx.M = 2; cfg.approx.uspace = 'eq';
% cfg.samples = 'randdisc N=10000';
% cfg.datafile = 'hc_testterm_lspe';
% cfg.evalduringsamples = 0;
% lspe(cfg);


%% CEFUZZYQI

cfg = ccfg;
cfg.run = 1;
cfg.Np = [7 7];                     % number of centers along each state dimension
cfg.N = [];                         % number of basis functions
cfg.X0 = 'pos';                     % (required) set of interesting initial states
cfg.U = [-4 4];                     % (required) flat action space, pxM
% CE config
cfg.ce_c = 4;                       % N = min(c * Nphi, Nmax), when auto
cfg.ce_rho = 3;                     % best samples at each iteration to use in updates
cfg.ce_alpha = .7;                  % smoothed update coefficient for mean of params distribution
cfg.ce_maxiter = 10;                % max # iterations for CE optimization
cfg.ce_d = 3;                       % how many iterations should the keep roughly constant to consider convergence
cfg.ce_eps = .001;                  % threshold for cost increase
cfg.datafile = 'hc_testterm_cefuzzyqi';
cfg.term = 'ignore';
cefuzzyqi(cfg);
