% Variant for SOOP benchmark: long horizon, smooth actions should be needed for a good solution

%% Run
cfg = struct;
cfg.model_params = {'rewtype=refnlqr xref=[pi/4;0] Qrew=[1,0.03] Rrew=0.3', 'type=ip maxu=3', 'Ts=0.05'};
cfg.problem = 'ipsetup_problem';
dummymodel = ipsetup_problem('model', cfg.model_params{:});
cfg.xgrids = symequidgrid(71, dummymodel.maxx);
cfg.ugrids = {symequidgrid(31, dummymodel.maxu)};
cfg.gamma = 0.95;
cfg.maxiter = 1000;
cfg.eps = 1e-3;
cfg.datadir = 'd:\work\m\approxrl\systems\invpend_setup\fuzzyqi_ipsetup\';
cfg.datafile = 'ipsetup_fuzzyqisolution_forsoopbenchmark';

cfg.run = 1;
fuzzyqi(cfg);


%% show
close all; 
cfg = struct;
cfg.datafile = 'ipsetup_fuzzyqisolution_forsoopbenchmark';
cfg.problem = 'ipsetup_problem';
cfg.replay = 1;
cfg.interph = 0;
cfg.x0 = [-pi, 0]';
cfg.tend = 3;
fuzzyqi(cfg);

cfg.fuzzyh = 1;
dc_plot(cfg);
