%% Common config
% close all;
clear all;

Uval = 4;
mcfg = struct;
mcfg.filter = 'none';
mcfg.rewtype = 'normadams';  % normalized!
odecfg = struct;
% algo config
cfg = struct;
cfg.planparams.U = flat({[0, 0.7], [0, 0.3]});
cfg.trials = 1;
cfg.reset = 'unhealthy';
cfg.maxsteps = 800/5;
cfg.verb = 3;
cfg.datadir = pwd;
cfg.problem = 'hiv_problem';
cfg.model_params = {mcfg, odecfg}; 
cfg.gamma = 0.98;
ccfg = cfg;



%% ONLINE OPD with n
tic;
cfg = ccfg;
cfg.planalg = 'opd';            % variant: optimistic planning for deterministic systems
cfg.planparams.n = 200;         % budget of expansions at each step
cfg.datafile = ['hivonl_opd_U' num2str(Uval) '_n=' num2str(cfg.planparams.n) '_S=' num2str(cfg.planparams.S)];
cfg.visualize = 0;
% cfg.saveplandata = 1;

% run the algorithm
cfg.run = 1;
genmpc(cfg);          

genmpc(['ploth datafile=' cfg.datafile]);

figure; hist=genmpc(['plottrial datafile=' cfg.datafile]);
fprintf('total return=%.5f\n\n',hist.R(1));
toc;

% for i=1:60, t1(i)=planinfoh(i).treesize; end;
% for i=1:60, t2(i)=planinfoh(i).treesize; end;
% plot(1:60,t`, 1:60,t2)


%% ONLINE OPD with n
tic;
cfg = ccfg;
cfg.planalg = 'okp';            % variant: optimistic planning for deterministic systems
cfg.planparams.n = 200;         % budget of expansions at each step
cfg.planparams.K = 8;
cfg.planparams.epsil = 10^(-10);
cfg.planparams.exploitredundancy = true;
cfg.datafile = ['hivonl_okp_U' num2str(Uval) '_n=' num2str(cfg.planparams.n) '_S=' num2str(cfg.planparams.S)];
cfg.visualize = 0;
% cfg.saveplandata = 1;

% run the algorithm
cfg.run = 1;
genmpc(cfg);          

genmpc(['ploth datafile=' cfg.datafile]);

figure; hist=genmpc(['plottrial datafile=' cfg.datafile]);
fprintf('total return=%.5f\n\n',hist.R(1));
toc;

% for i=1:60, t1(i)=planinfoh(i).treesize; end;
% for i=1:60, t2(i)=planinfoh(i).treesize; end;
% plot(1:60,t`, 1:60,t2)
