%%online tests for okp IPsetup, for various n and K values
clear all;  close all;
Uval = 2;
K = 16;
M = 3;
narray = [600:300:4500 6000 7500];
testParamNames = '_U=2_K=16';

opd_ret = narray;
okp_ret = narray;
okpEqTree_ret = narray;
for n=narray,
    %online OPD
    cfg.datafile = ['iponl_opd' testParamNames '_nsim=' num2str(n)];
    figure(3); hist=genmpc(['plottrial datafile=' cfg.datafile]);
    opd_ret(narray==n) = hist.R(1);
    
    %online okp exploiting redundancy
    cfg.datafile = ['iponl_okp' testParamNames '_nsim=' num2str(n)];   
    figure(3); hist=genmpc(['plottrial datafile=' cfg.datafile]);
    okp_ret(narray==n) = hist.R(1);
    
    %online okp exploiting redundancy equal treesize
    cfg.datafile = ['iponl_okp_eqTree' testParamNames '_nsim=' num2str(n)];   
    figure(3); hist=genmpc(['plottrial datafile=' cfg.datafile]);
    okpEqTree_ret(narray==n) = hist.R(1);
end;

figure;
plot(narray,opd_ret,'-s', narray,okp_ret,'-*', narray,okpEqTree_ret,'-o');
legend('OPD','OKP','OKP equal treesize');
title(['IPS Return for various n, ' testParamNames]);


%% tests for various K, n=640
n = 640;
Karray = [1 2 4 5 8 10 16 20 32];
opd_ret = Karray;
okp_ret = Karray;
okpEqTree_ret = Karray;
for K=Karray,
    %online OPD
    cfg.datafile = ['iponl_U2_opd_n=' num2str(n)];
    figure(4); hist=genmpc(['plottrial datafile=' cfg.datafile]);
    opd_ret(Karray==K) = hist.R(1);
     
    %online okp exploiting redundancy
    cfg.datafile = ['iponl_U2_okp_expred_n=' num2str(n) 'K=' num2str(K)];   
    figure(4); hist=genmpc(['plottrial datafile=' cfg.datafile]);
    okp_ret(Karray==K) = hist.R(1);
    
    %online okp exploiting redundancy equal treesize
    cfg.datafile = ['iponl_U2_okp_expred_eqTree_n=' num2str(n) 'K=' num2str(K)];   
    figure(4); hist=genmpc(['plottrial datafile=' cfg.datafile]);
    okpEqTree_ret(Karray==K) = hist.R(1);
end;

figure;
plot(Karray,opd_ret,'-s', Karray,okp_ret,'-*', Karray,okpEqTree_ret,'-o');
legend('OPD','OKP','OKP equal treesize');
title('IPS Return for various K, n=640');